//+------------------------------------------------------------------+
//|                                           ind_FletChannel_07.mq4 |
//|                                            Copyright  2013, sv. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, sv."
#property link      "7009731@mail.ru"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
//----
extern int    Distans     = 100;
extern int    Channel     = 76;
extern int    ZoneUnSence = 12;
extern int    PauseBar    = 20;
//----
double Up[];
double Down[];
double UpSupport[];
double DownResistance[];

double pnt;
double high, low;
double high_1, low_1;
bool   up_chanel, dn_chanel, FirstChanel;
bool   DrawChannel;
int    History=0; // 0-  
int    n,n_up,n_dn;
int    Bar;

//+------------------------------------------------------------------+
int init() {
//----
   pnt=Point;
   if(Digits==5 || Digits==3) pnt*=10;
   high_1=0;
   low_1=0;
   DrawChannel=false;
   n=0;
   n_up=0;
   n_dn=0;
   
   IndicatorDigits(Digits);
   IndicatorBuffers(4);
//----      
   SetIndexBuffer(0,Up);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexEmptyValue(0,0.0);

   SetIndexBuffer(1,Down);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexBuffer(2,UpSupport);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexEmptyValue(2,0.0);

   SetIndexBuffer(3,DownResistance);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexEmptyValue(3,0.0);
//----      
   return(0);
}
//+------------------------------------------------------------------+
int start() 
{ 

  int i;
  int limit=Bars-IndicatorCounted()-1; 
  if(limit>1) 
  {
    limit=Bars-1;
  }
  if(History!=0 && limit>History) 
  {
    limit=History-1; // -   
  }

  Bar=limit;

   for(i=limit; i>=0; i--) 
   {
     if(i<Bar-PauseBar)
     {
       //     ,  .
       if(DrawChannel==false)
       {
         //        Distans
         double low = iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Distans,i));
         double high = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Distans,i));
         //            Channel
         if((high-low)<Channel*pnt)
         {
           DrawChannel=true;
         }
       }  
     }
     
     if(DrawChannel)
     {  
       //          Distans
       //    
       if(FirstChanel)
       {
         Up[i]   = high;
         Down[i] = low;
       }
       //    
       if(up_chanel)
       {
         Up[i]=high;
         UpSupport[i]=high-Channel*pnt;
       }
       //    
       if(dn_chanel)
       {
         Down[i]=low;
         DownResistance[i]=low+Channel*pnt;
       }
       //     
       if(high_1==0 && low_1==0)
       { 
         FirstChanel=true; 
         high_1=high;
         low_1=low;
       }
       //        
       else
       { 
         //          ,    
         if(high>high_1)
         {
           //      
           up_chanel=true;
           //   
           high_1=high;
           low_1=low;
         }
         //          ,    
         if(low<low_1)
         {
           //      
           dn_chanel=true;
           //   
           high_1=high;
           low_1=low;
         }
       }  
       //   ,    
     
       if(Up[i]!=0 && UpSupport[i]!=0)
       {
         if(Close[i]>Up[i]+ZoneUnSence*pnt || Close[i]<UpSupport[i]-ZoneUnSence*pnt)
         {
           //    ,  
           up_chanel=false;
           dn_chanel=false;
           FirstChanel=false; 
           DrawChannel=false;
         }
       } 
       if(Down[i]!=0 && DownResistance[i]!=0)
       {
         if(Close[i]>DownResistance[i]+ZoneUnSence*pnt || Close[i]<Down[i]-ZoneUnSence*pnt)
         {
           //    ,  
           up_chanel=false;
           dn_chanel=false;
           FirstChanel=false;
           DrawChannel=false;
         }
       }
       if(Up[i]!=0 && Down[i]!=0)
       {
         if(Close[i]>Up[i]+ZoneUnSence*pnt || Close[i]<Down[i]-ZoneUnSence*pnt)
         {
           //    ,  
           up_chanel=false;
           dn_chanel=false;
           FirstChanel=false; 
           DrawChannel=false;
         }
       }
       Bar=i; 
     }    
   
   } 

//----
   return(0);
}
//+------------------------------------------------------------------+


